;
; Module address definition
;
	ncoin =  7
	nadc1 = 12
	nadc2 = 14
	nadc3 = 16
	nadc4 = 18

;
; CAMAC-module initialization routine 
;	which will be called at start of data-acquisition.  
;
intmdl::
	;
	; Clear modules (but scalers are reset by Host)
	;
	NDT	nadc1,0,9	; module clear A(0)F(9)
	NDT	nadc2,0,9	; module clear A(0)F(9)
	NDT	nadc3,0,9	; module clear A(0)F(9)
	NDT	nadc4,0,9	; module clear A(0)F(9)
	;
	; Setup modules (which may have been initialized unexpectedly !)
	;
;	W1W	nmem1,1,17,3	; set ECL Mode A(1)F(17)D(3)
;	W1W	nopr,0,17,8	; Clear FERA&Memory A(0)F(17)D(8)
	;
	; enable LAM to check conversion end
	;
	NDT	nadc1,0,26
	;
	Rts

;
; Interrupt service routine for the External Trigger, 
;	which will be called on each event.  
;
Trig::	;
	; === do not change from here ===
	;
	Move.L	A6,A2		; Keep start address for word
	;
	; Event Header
	;
	Move.W	(seqnum),D0	; event sequential number (esn)
	AddI.W	#1,D0		; increment esn
	Move.W	D0,(seqnum)	; store esn
	AndI.W	#$00FF,D0	; clear higher byte
	OrI.W	#header,D0	; Set Header bit
	Move.W	D0,(A6)+	; Write to buffer
	Tst.W	(A6)+		; Make space for Event Length
	;
	; ===                to  here ===
	;
	; Read coin register and save values.
	;
;	R1WD0	ncoin,0,2	; read Coin reg with A(0)F(2)
	;
	; Read Event Data
	;
;	WAITQ	nadc1,0,8	; Wait conversion end
	;
	;
	; Read ADCs
	;
RID1::	BEGREG 1
	SRW	nadc1,0,2,1,16	; Address Scan Read with F(2), 16 words
	ENDREG
RID2::	BEGREG 2
	SRW	nadc2,0,2,1,16	; Address Scan Read with F(2), 16 words
	ENDREG
RID3::	BEGREG 3
	SRW	nadc3,0,2,1,16	; Address Scan Read with F(2), 16 words
	ENDREG
RID4::	BEGREG 4
	SRW	nadc4,0,2,1,16	; Address Scan Read with F(2), 16 words
	ENDREG

bitx::
	;
	; Clear Modules
	;
	NDT	nadc1,0,9	; Clear module A(0)F(9)
	NDT	nadc2,0,9	; Clear module A(0)F(9)
	NDT	nadc3,0,9	; Clear module A(0)F(9)
	NDT	nadc4,0,9	; Clear module A(0)F(9)
	;
	; === Never change below if you are an ordinary user ===
	;
	; Store Event Length
	;
	Move.L	A6,D0		; Get current buffer pointer
	Sub.L	A2,D0		; Subtract the start address
	Move.W	D0,(2,A2)	; write Header
	;
	; Check buffer boundary
	;
	MoveA.L	(bcbw),A1	; Get address of BCB
	Move.L	A6,(16,A1)	; Store current buffer pointer
	Move.L	(4,A1),D0	; Get buffer limit
	SubI.L	#scasiz,D0	; Subtract size of scaler acrea
	SubI.L	#maxevl,D0	; Subtract next event length
	Cmp.L	A6,D0		; Check enough room exist
	Bhi	endev1		; branch if yes
	Bsr	exchbf		; change buffer for next event
	Rte			; leave endisr output to Host
	;
	; (Display status and) generate CPU ready signal
	;
endev1::
	W1W	nopr,0,17,endisr	; output register
endevr:
	Rte			; return from interrupt
